View this page in the latest version of Appian. Salesforce Connected System Share Share via LinkedIn Reddit Email Copy Link Print On This Page Overview Manage your customer information and interactions. Find, update, create, or delete records within your Salesforce instance. Three forms of authentication are available for Salesforce: Username-Password OAuth: One account is used for server-to-server communication between Appian and Salesforce. Salesforce recommends updating connections using username-password authentication to use client credentials instead. Client Credentials OAuth: One account is used for server-to-server communication between Appian and Salesforce. Web Server OAuth: Each user signs in with their own credentials. For information that pertains to all connected systems, see Connected System Object. Username-Password OAuth authentication Provide a single Salesforce user's credentials to authenticate. All integrations will use a shared Salesforce username and password. Individual Appian users do not need their own Salesforce accounts. See Salesforce Username-Password OAuth documentation for more details. If you are using a record type to sync your Salesforce data in Appian, you should use the Username-Password OAuth Authentication in the Salesforce Connected System. Test your connection before syncing your data to identify and resolve any authentication issues beforehand. The Salesforce Username-Password OAuth authentication has the following properties: Field Description Name Required. The name of the connected system. Use a name that will uniquely identify this connection to the external system. Description Supplemental information about the connected system that is displayed in the objects grid of some Designer views and when selecting the system in an integration object. System Logo An image document used to visually represent the external system or service being connected to. The logo is displayed in the integration designer and in the Process Modeler on integrations that connect to this system (using the Call Integration Smart Service). If no document is selected a default logo will be used instead. Authentication Set to Username-Password OAuth. Instance URL* Required. Instance URL will be used for authorization. This URL is used to configure your integration object and when executing your operations. For example, https://na59.salesforce.com Client Id* Required. In the Salesforce Setup portal, navigate to App Manager, and then find your App and select View. The Client Id will be listed on this page as "Consumer Key". See Salesforce set up documentation for more details. Client Secret* Required/Sensitive. In the Salesforce Setup portal, navigate to App Manager, and then find your App and select View. The Client Secret will be listed on this page as "Consumer Secret". See Salesforce set up documentation for more details. Username* Required. The username used to sign into the provided Salesforce instance Password* Required/Sensitive. The password used to sign into the provided Salesforce instance Security Token* Required/Sensitive. This is an automatically-generated user security token from Salesforce. In the Salesforce personal settings for the user, select Reset My Security Token to generate a new security token. When authorizing, this security token will be appended to the password. See Salesforce security token documentation for more details. Data Source Shortcut Determines whether to show the connected system as a data source shortcut in the record type configuration. Shortcut Display Name The name of the data source shortcut option. This property only appears when Data Source Shortcut is selected. * This value is included in an import customization file so that you can specify a different value for each environment. Sensitive values will not be exported in the import customization file and must be added manually. Required fields must have a value upon import or else import will fail. For more information on import/export behavior, see the Connected Systems Object page. Client Credentials OAuth authentication With this authentication method, all integrations will use one set of credentials to access Salesforce. Individual Appian users do not need their own Salesforce accounts. See Salesforce OAuth 2.0 client credentials documentation for more details about setting up your Salesforce app to use this authentication type. The Salesforce Client Credentials OAuth authentication has the following properties: Field Description Name Required. The name of the connected system. Use a name that will uniquely identify this connection to the external system. Description Supplemental information about the connected system that is displayed in the objects grid of some views and when selecting the system in an integration object. System Logo An image document used to visually represent the external system or service being connected to. The logo is displayed in the integration designer and in the Process Modeler on integrations that connect to this system (using the Call Integration Smart Service). If no document is selected a default logo will be used instead. Authentication Set to Client Credentials OAuth. Instance URL* Required. This URL is used when authenticating the connected system, configuring your integration objects, and when executing your operations. For example, https://na59.salesforce.com. Client ID* Required. The consumer key from your Salesforce app definition. For External Client Apps, navigate to External Client App Manager, open your app, and select Settings > OAuth Settings.For Connected Apps, navigate to "App Manager", find your app, click , and then click Manage Consumer Details. See Salesforce set up documentation for more details. Client Secret* Required/Sensitive. The consumer secret from your Salesforce app definition. For External Client Apps, navigate to External Client App Manager, open your app, and select Settings > OAuth Settings.For Connected Apps, navigate to "App Manager", find your app, click , and then click Manage Consumer Details. See Salesforce set up documentation for more details. Data Source Shortcut Determines whether to show the connected system as a data source shortcut in the record type configuration. Shortcut Display Name The name of the data source shortcut option. This property only appears when Data Source Shortcut is selected. * This value is included in an import customization file so that you can specify a different value for each environment. Sensitive values will not be exported in the import customization file and must be added manually. Required fields must have a value upon import or else import will fail. For more information on import/export behavior, see the Connected Systems Object page. Web Server OAuth authentication Each Appian user will be required to sign in to their Salesforce account to authenticate. You must provide users a way to authenticate using OAuth 2.0. See Salesforce Web Server OAuth documentation for more details. The Salesforce Web Server OAuth authentication has the following properties: Field Description Name Required. The name of the connected system. Use a name that will uniquely identify this connection to the external system. Description Supplemental information about the connected system that is displayed in the objects grid of some Designer views and when selecting the system in an integration object. System Logo An image document used to visually represent the external system or service being connected to. The logo is displayed in the integration designer and in the Process Modeler on integrations that connect to this system (using the Call Integration Smart Service). If no document is selected a default logo will be used instead. Authentication Set to Web Server OAuth. Instance URL* Required. Instance URL will be used for authorization. This URL is used to configure your integration object and when executing your operations. For example: https://na59.salesforce.com Client Id* Required. In the Salesforce Setup portal, navigate to App Manager, and then find your App and select View. The Client Id will be listed on this page as "Consumer Key". See Salesforce set up documentation for more details. Client Secret* Required/Sensitive. In the Salesforce Setup portal, navigate to App Manager, and then find your App and select View. The Client Secret will be listed on this page as "Consumer Secret". See Salesforce set up documentation for more details. Scopes Required. In the Salesforce Setup portal, navigate to App Manager, and then find your App and select View. The scopes will be listed on this page as "Selected OAuth Scopes". This connected system requires API and refresh token access. You must provide API access using either the api or full scope. See Salesforce scope documentation for more details. Data Source Shortcut Determines whether to show the connected system as a data source shortcut in the record type configuration. Shortcut Display Name The name of the data source shortcut option. This property only appears when Data Source Shortcut is selected. * This value is included in an import customization file so that you can specify a different value for each environment. Sensitive values will not be exported in the import customization file and must be added manually. Required fields must have a value upon import or else import will fail. For more information on import/export behavior, see the Connected Systems Object page. Click AUTHORIZE to use the provided configuration information to authorize the designer in a new window. See OAuth 2.0: Authorization Code Grant for more details. Automating property updates This object's properties can also be updated programmatically using the Update Connected System endpoint. This lets you change passwords, API keys, and other values without needing to sign in to Appian. The following properties can be included in the JSON request body of the PATCH /connected-system/<UUID> call. Authentication Type Available Properties Web Server OAuth instanceURL, clientId, clientSecret Client Credentials OAuth instanceURL, clientId, clientSecret Username-Password OAuth instanceURL, clientId, clientSecret, instanceUsername, instancePassword, securityToken Operations Name Description Type Create SObject Adds a new business object to Salesforce WRITE Update SObject Updates data for an existing business object in Salesforce WRITE Delete SObject Removes a business object from Salesforce WRITE SOQL Query Allows querying a Salesforce instance using the Salesforce Object Query Language (SOQL) READ SOSL Search Allows searching a Salesforce instance using the Salesforce Object Search Language (SOSL) READ Describe SObject Provides introspection into the metadata of the given Salesforce objects READ Describe All SObjects Provides introspection into the objects available in the target Salesforce instance READ Create SObject Adds a new business object to Salesforce Create SObject is a WRITE type Integration. To prevent the integration from making the same update twice, it can only be used in the saveInto parameter of an interface component or in a Web API. See Call an Integration for more information. Update SObject Updates data for an existing business object in Salesforce Update SObject is a WRITE type Integration. To prevent the integration from making the same update twice, it can only be used in the saveInto parameter of an interface component or in a Web API. See Call an Integration for more information. Delete SObject Removes a business object from Salesforce Delete SObject is a WRITE type Integration. To prevent the integration from making the same update twice, it can only be used in the saveInto parameter of an interface component or in a Web API. See Call an Integration for more information. SOQL Query Allows querying a Salesforce instance using the Salesforce Object Query Language (SOQL) When creating a Connected System that connects to a Salesforce instance, Appian offers the functionality to Provide your own SOQL Query. When providing your own SOQL, developers can run any SOQL query they wish. Be aware that doing so could allow developers to create insecure SOQL queries that lead to SOQL injection. To mitigate this risk, it is recommended that designers follow the Salesforce SOQL developer best practices for SOQL injection when supplying their own queries. SOSL Search Allows searching a Salesforce instance using the Salesforce Object Search Language (SOSL) Describe SObject Provides introspection into the metadata of the given Salesforce objects Describe All SObjects Provides introspection into the objects available in the target Salesforce instance Feedback Was this page helpful? SHARE FEEDBACK Loading...